/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.efectivo;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.caja.SQLiteCajaDAO;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public abstract class EfectivoDAO {
    private static final Logger LOGGER = Logger.getLogger(EfectivoDAO.class.getName());

    protected ConnectionHolder connectionHolder;

    public abstract List<Efectivo> findAll();

    public abstract Efectivo findById(int id);

    public abstract Efectivo findByCaja(Caja caja);

    public abstract boolean insertEfectivo(Efectivo efectivo);

    public abstract boolean insertDefaultEfectivo(Efectivo efectivo);

    public abstract boolean updateEfectivo(Efectivo efectivo);

    public abstract boolean deleteEfectivo(Efectivo efectivo);

    public abstract int getTotalEfectivo(Caja caja);

    protected List<Efectivo> efectivosFromResultSet(ResultSet rs) throws SQLException {
        List<Efectivo> efectivoList = new ArrayList<>();
        while (rs.next()) {
            CajaDAO cajaDAO = new SQLiteCajaDAO();
            Caja caja = cajaDAO.findById(rs.getInt("caja_id"));

            Efectivo efectivo = new Efectivo();
            efectivo.setCaja(caja);
            efectivo.setId(rs.getInt("id"));
            efectivo.setVeinteMil(rs.getInt("veinte_mil"));
            efectivo.setDiezMil(rs.getInt("diez_mil"));
            efectivo.setCincoMil(rs.getInt("cinco_mil"));
            efectivo.setDosMil(rs.getInt("dos_mil"));
            efectivo.setMil(rs.getInt("mil"));
            efectivo.setQuinientos(rs.getInt("quinientos"));
            efectivo.setCien(rs.getInt("cien"));
            efectivo.setCincuenta(rs.getInt("cincuenta"));
            efectivo.setDiez(rs.getInt("diez"));

            LOGGER.log(Level.FINER, "Se a creo: {0}", efectivo);

            efectivoList.add(efectivo);
        }
        return efectivoList;
    }
}
